#pragma once
#ifdef _MSVC
	#pragma warning (disable: 4786)
#endif

#include <stdio.h>
#include <assert.h>
#include <ctype.h>
#include <string>
#include <algorithm>
#include <list>
using namespace std;
#include "bsch3com/xbschstringlist.h"
#include "bsch3com/ce3io.h"
#include "bsch3com/xbschobj.h"
#include "bsch3com/xbschjunc.h"
#include "bsch3com/xbschlabel.h"
#include "bsch3com/xbschcomment.h"
#include "bsch3com/xbschtag.h"
#include "bsch3com/xbschcomponent.h"

#include "bsch3com/xbschline.h"
#include "bsch3com/xbschwirenl.h"
#include "bsch3com/xbschentry.h"
#include "bsch3com/xbschdelobj.h"
#include "bsch3com/xbschsheetinfo.h"
#include "bsch3com/xbschdoc.h"

#define MAX_SCH_FILES 64 

class SNutDataFile
{
public:
	string m_filename;
	SXBSchDoc* m_pDoc;
	SNutDataFile(){m_pDoc=NULL;}
	~SNutDataFile();
};

class SNutComponent
{
public:
	int m_index;
	SXBSchComponent* m_pObj;
	bool m_set;
	bool m_powComp;
	string m_prefix;
	int m_suffix;
	SNutComponent();
	void loadRef();
	void saveRef();
	//bool operator<(const SNutComponent &a)const;
};


typedef list<SNutComponent*> NutCompList;
typedef list<SNutComponent*>::iterator NutCompListIterator;
typedef SNutComponent* PSNutComponent;

class SNut
{
	int m_dataFileCount;
	SNutDataFile m_schFiles[MAX_SCH_FILES];

	PSNutComponent* m_compArray;
	int m_compArrayCount;
	//PSNutComponent* m_powcompArray;
	//int m_powcompArrayCount;
	void pickupComponent(bool renumMode);
	void clearCompArray();
	void clearSchFiles();
	void sortPOS();
	void sortREF();
	//void createBackup();

public:
	SNut();
	~SNut();
	int fileCount(){return m_dataFileCount;}
	int readFile(const char* path);	//ɤ߹ߤ0ʳ֤
	int saveFiles();
	int anum(int init,int step);
	int renum(int init,int step);

};
